server/sandbox/urls.py
from django.apps import apps
from django.conf import settings
from django.conf.urls import i18n, include
from django.contrib import admin
from django.urls import path
from django.views.static import serve
import debug_toolbar

urlpatterns = [
    path("i18n/", include(i18n)),
    path("admin/", admin.site.urls),
    path(
        "media/<path:path>",
        serve,
        {"document_root": settings.MEDIA_ROOT, "show_indexes": True},
    ),
    path("__debug__/", include(debug_toolbar.urls)),
    path(
        "",
        include(apps.get_app_config("oscar").urls[0]),  # type:ignore[attr-defined]
    ),
]

server/src/oscarbluelight/dashboard/offers/models.py
from oscar.apps.dashboard.offers.models import *  # noqa

server/src/oscarbluelight/dashboard/ranges/models.py
from oscar.apps.dashboard.ranges.models import *  # noqa

server/src/oscarbluelight/offer/models.py
from __future__ import annotations

from collections.abc import Collection, Iterable
from datetime import datetime, timedelta
from decimal import Decimal
from typing import TYPE_CHECKING, Any, Optional, TypedDict, TypeVar
import copy
import logging
import math
import time

from django.conf import settings
from django.core import exceptions
from django.db import IntegrityError, connection, models
from django.db.models import F, Q, QuerySet
from django.db.models.base import ModelBase
from django.utils import timezone
from django.utils.encoding import force_str
from django.utils.functional import cached_property
from django.utils.translation import gettext_lazy as _
from oscar.apps.offer.abstract_models import (
    AbstractBenefit,
    AbstractCondition,
    AbstractConditionalOffer,
    AbstractRange,
    AbstractRangeProduct,
    AbstractRangeProductFileUpload,
)
from oscar.apps.offer.results import ApplicationResult
from oscar.apps.offer.utils import load_proxy
from oscar.core.loading import get_class, get_model
from oscar.models.fields import AutoSlugField  # type:ignore[attr-defined]
from oscar.templatetags.currency_filters import currency
from thelabdb.pgviews import view as pg

from .results import (
    SHIPPING_DISCOUNT,
    ZERO_DISCOUNT,
    BasketDiscount,
    OfferApplication,
    PostOrderAction,
    ShippingDiscount,
)
from .sql import SQL_RANGE_PRODUCTS, get_recalculate_offer_application_totals_sql

if TYPE_CHECKING:
    from django_stubs_ext import StrOrPromise
    from oscar.apps.catalogue.expressions import ExpandDownwardsCategoryQueryset
    from oscar.apps.catalogue.models import Product
    from oscar.apps.order.models import Order as _Order
    from oscar.apps.order.models import OrderDiscount as _OrderDiscount

    from ..mixins import BluelightBasketMixin as Basket
    from ..voucher.models import Voucher as _Voucher
    from .upsells import OfferUpsell
else:
    ExpandDownwardsCategoryQueryset = get_class(
        "catalogue.expressions", "ExpandDownwardsCategoryQueryset"
    )

logger = logging.getLogger(__name__)

T = TypeVar("T", bound=type[models.Model])


def _init_proxy_class(obj: T, Klass: type[T]) -> T:
    # Check if we're already the correct class
    if obj.__class__ == Klass:  # type:ignore[comparison-overlap]
        return obj

    # Check if we're using multi-table inheritance
    model_name = Klass._meta.model_name  # type:ignore[attr-defined]
    if hasattr(obj, model_name):
        return getattr(obj, model_name)

    # Else, it's just a proxy model
    proxy = copy.deepcopy(obj)
    proxy.__class__ = Klass  # type:ignore[method-assign, assignment]
    return proxy


class AvailabilityRestriction(TypedDict):
    description: str
    is_satisfied: bool


class OfferGroup(models.Model):
    """
    Ordered group of Offers
    """

    name = models.CharField(max_length=64, null=False)
    slug = AutoSlugField(populate_from="name", unique=True, null=True, overwrite=True)
    priority = models.IntegerField(null=False, unique=True)
    is_system_group = models.BooleanField(default=False, editable=False)

    class Meta:
        verbose_name = _("OfferGroup")
        ordering = ("-priority",)

    def __str__(self) -> str:
        return "{} (priority {})".format(self.name, self.priority)


class ConditionalOffer(AbstractConditionalOffer):
    """
    groups  -- user groups
    offer_group -- FK to OfferGroup
    offerGroupA => [ o1, v2, o3 ], priority 1
    offerGroupB => [ o4, v3 ], priority 2
    To consume offers, loop through offers in offer group based on priority
    to consume OfferGroup -> only move to next (greater priority val) when previous
    offerGroup is consumed
    """

    short_name = models.CharField(
        _("Short Name"), max_length=50, help_text=_("Abbreviated version of offer name")
    )
    desktop_image = models.ImageField(
        _("Ad Image (Desktop)"),
        null=True,
        blank=True,
        upload_to=getattr(settings, "BLUELIGHT_OFFER_IMAGE_FOLDER"),
        help_text=_("Desktop image used for promo display."),
    )
    mobile_image = models.ImageField(
        _("Ad Image (Mobile)"),
        null=True,
        blank=True,
        upload_to=getattr(settings, "BLUELIGHT_OFFER_IMAGE_FOLDER"),
        help_text=_("Mobile image used for promo display."),
    )
    # When offer_type == "User", we use groups to determine which users get the offer
    groups = models.ManyToManyField(
        "auth.Group",
        verbose_name=_("User Groups"),
        blank=True,
        help_text=_(
            "Select which User Groups are eligible for this offer. If none are selected, all "
            "users are eligible."
        ),
    )
    offer_group = models.ForeignKey(
        OfferGroup,
        verbose_name=_("Offer Group"),
        related_name="offers",
        null=True,
        on_delete=models.CASCADE,
        help_text=_(
            "Select the Offer Group that this offer belongs to. Offer Group controls the order "
            "offers are applied in and which offers may be combined together."
        ),
    )
    affects_cosmetic_pricing = models.BooleanField(
        _("Affects Cosmetic Pricing?"),
        default=True,
        help_text=_(
            "Controls whether or not this offer will affect advertised product prices. Turn off "
            "for offers which should only apply once the product is in a customer's basket."
        ),
    )

    class Meta:
        ordering = ("-offer_group__priority", "-priority", "pk")

    @classmethod
    def recalculate_offer_application_totals(cls) -> None:
        Order: type["_Order"] = get_model("order", "Order")
        OrderDiscount: type["_OrderDiscount"] = get_model("order", "OrderDiscount")
        start_ns = time.perf_counter_ns()
        update_sql = get_recalculate_offer_application_totals_sql(
            Order=Order,
            OrderDiscount=OrderDiscount,
            ConditionalOffer=cls,
            ignored_order_statuses=settings.BLUELIGHT_IGNORED_ORDER_STATUSES,
        )
        with connection.cursor() as cursor:
            cursor.execute(update_sql)
            updated_rows = cursor.rowcount
        end_ns = time.perf_counter_ns()
        elasped_ms = (end_ns - start_ns) / 1_000_000
        logger.info(
            "Successfully recalculated offer application totals in %.3fms. Updated %d offers.",
            elasped_ms,
            updated_rows,
        )

    def availability_restrictions(self) -> list[AvailabilityRestriction]:
        restrictions: list[AvailabilityRestriction] = (
            super().availability_restrictions()
        )
        if self.offer_type == self.USER:
            restrictions.append(
                {
                    "description": _("Offer is limited to user groups: %s")
                    % ", ".join(g.name for g in self.groups.all()),
                    "is_satisfied": True,
                }
            )
        return restrictions

    def get_upsell_details(self, basket: Basket) -> Optional[OfferUpsell]:
        return self.condition.proxy().get_upsell_details(self, basket)

    def apply_benefit(self, basket: Basket) -> ApplicationResult:
        try:
            return super().apply_benefit(basket)
        except Exception as e:
            logger.exception(e)
            return ZERO_DISCOUNT

    def record_usage(self, discount: OfferApplication) -> None:
        ConditionalOffer.objects.filter(pk=self.pk).update(
            num_applications=(F("num_applications") + discount["freq"]),
            total_discount=(F("total_discount") + discount["discount"]),
            num_orders=(F("num_orders") + 1),
        )

    record_usage.alters_data = True  # type:ignore[attr-defined]


class Benefit(AbstractBenefit):
    # Use this field to provide an hard-cap on the discount amount than a benefit
    # can provide.
    max_discount = models.DecimalField(
        _("Max discount"),
        decimal_places=2,
        max_digits=12,
        null=True,
        blank=True,
        help_text=_(
            "If set, do not allow this benefit to provide a discount greater "
            "than this amount (for a particular basket application)."
        ),
    )

    def proxy(self) -> Benefit:
        if self.proxy_class:
            Klass = load_proxy(self.proxy_class)
            return _init_proxy_class(self, Klass)
        return super().proxy()

    @property
    def name(self) -> StrOrPromise:
        return force_str(super().name)

    @property
    def type_name(self) -> str:
        benefit_classes = getattr(settings, "BLUELIGHT_BENEFIT_CLASSES", [])
        names = dict(benefit_classes)
        names["oscarbluelight.offer.benefits.CompoundBenefit"] = _("Compound benefit")
        return names.get(self.proxy_class, self.proxy_class)

    @property
    def non_voucher_offers(self) -> QuerySet[ConditionalOffer]:
        return self.offers.exclude(offer_type=ConditionalOffer.VOUCHER).all()

    @property
    def vouchers(self) -> list[_Voucher]:
        vouchers = []
        for offer in self.offers.filter(offer_type=ConditionalOffer.VOUCHER).all():
            for voucher in offer.vouchers.filter(parent=None).all():
                vouchers.append(voucher)
        return vouchers

    def clean(self) -> None:
        if self.type:
            raise exceptions.ValidationError(
                _("Benefit should not have a type field. Use proxy class instead.")
            )
        proxy_instance = self.proxy()
        cleaner = getattr(proxy_instance, "_clean", None)
        if cleaner and callable(cleaner):
            return cleaner()
        return super().clean()

    def save(
        self,
        force_insert: bool | tuple[ModelBase, ...] = False,
        force_update: bool = False,
        using: str | None = None,
        update_fields: Iterable[str] | None = None,
    ) -> None:
        ret = super().save(
            force_insert=force_insert,
            force_update=force_update,
            using=using,

server/src/oscarbluelight/dashboard/vouchers/forms.py
from __future__ import annotations

from typing import Any

from django import forms
from django.contrib.auth.models import Group
from django.utils import timezone
from django.utils.translation import gettext_lazy as _
from oscar.apps.dashboard.vouchers.forms import VoucherForm as BaseVoucherForm
from oscar.forms.widgets import DateTimePickerInput

from oscarbluelight.offer.models import ConditionalOffer
from oscarbluelight.voucher.models import Voucher

MAX_CHILDREN_CREATE = 100_000


class VoucherForm(BaseVoucherForm):
    name = forms.CharField(
        label=_("Name"),
        required=True,
        max_length=128,
    )

    # Child Codes
    _child_creation_type_choices = [
        ("none", _("Don't Create Child Codes")),
        ("auto", _("Auto-Generate Child Codes")),
        ("manual", _("Manually Enter Child Codes")),
    ]
    child_creation_type = forms.ChoiceField(
        label=_("Create Child Codes?"),
        help_text=_("What kind of child codes do you want to generate?"),
        choices=_child_creation_type_choices,
        widget=forms.RadioSelect,
    )
    auto_generate_child_count = forms.IntegerField(
        label=_("How many child codes should be created?"),
        initial=0,
        min_value=0,
        max_value=MAX_CHILDREN_CREATE,
        required=False,
    )
    custom_child_codes = forms.CharField(
        label=_("Custom Child Codes"),
        help_text=_(
            "Create custom child codes for this voucher by entering 1 code per line."
        ),
        required=False,
        widget=forms.Textarea(
            attrs={
                "class": "no-widget-init",  # Prevent Oscar Js from making this a TinyMCE WSSIWYG field
                "cols": 20,
                "rows": 5,
            }
        ),
    )

    usage = forms.ChoiceField(label=_("Usage"), choices=Voucher.USAGE_CHOICES)
    limit_usage_by_group = forms.BooleanField(
        label=_("Should usage be limited to specific user groups?"), required=False
    )
    groups = forms.ModelMultipleChoiceField(
        label=_("User Group Whitelist"),
        help_text=_("Which user groups will be able to apply this offer?"),
        queryset=Group.objects.order_by("name"),
        required=False,
    )
    # Because we're using pagination and leveraging select2's remote data sets capability to populate the offers field,
    # there's no need to send a potentially large queryset to the client side.
    offers = forms.ModelMultipleChoiceField(
        label=_("Which offers apply for this voucher?"),
        queryset=ConditionalOffer.objects.none(),
    )

    class Meta(BaseVoucherForm.Meta):
        fields = BaseVoucherForm.Meta.fields + [
            "child_creation_type",
            "auto_generate_child_count",
            "custom_child_codes",
            "usage",
            "limit_usage_by_group",
            "groups",
        ]

    def __init__(self, *args: Any, **kwargs: Any) -> None:
        super().__init__(*args, **kwargs)
        if self.instance.pk:
            self.fields["offers"].queryset = (  # type:ignore[attr-defined]
                self.instance.offers.all()
            )

    def clean_custom_child_codes(self) -> list[str]:
        code_txt = self.cleaned_data["custom_child_codes"]
        codes = [code.strip() for code in code_txt.splitlines()]
        return codes

    def is_valid(self) -> bool:
        # To ensure the selected value is considered valid/invalid correctly during the form's validation process,
        # update the `offers` field queryset to include all possible voucher-type offer choices.
        self.fields["offers"].queryset = (  # type:ignore[attr-defined]
            ConditionalOffer.objects.filter(offer_type=ConditionalOffer.VOUCHER)
        )
        res = super().is_valid()
        return res


class AddChildCodesForm(forms.Form):
    _creation_type_choices = [
        ("auto", _("Auto-Generate Codes")),
        ("manual", _("Manually Enter Codes")),
    ]
    creation_type = forms.ChoiceField(
        label=_("Child Code Creation Mode"),
        help_text=_("What kind of child codes do you want to generate?"),
        choices=_creation_type_choices,
        widget=forms.RadioSelect,
    )
    auto_generate_count = forms.IntegerField(
        label=_("Auto-Generated Child Code Count"),
        help_text=_("How many random child codes should be created?"),
        required=False,
        initial=0,
        min_value=0,
        max_value=MAX_CHILDREN_CREATE,
    )
    custom_child_codes = forms.CharField(
        label=_("Custom Child Codes"),
        help_text=_(
            "Create custom child codes for this voucher by entering 1 code per line."
        ),
        required=False,
        widget=forms.Textarea(
            attrs={
                "cols": 20,
                "rows": 5,
            }
        ),
    )

    def clean_custom_child_codes(self) -> list[str]:
        code_txt = self.cleaned_data["custom_child_codes"]
        codes = [code.strip() for code in code_txt.splitlines()]
        return codes


class CodeExportForm(forms.Form):
    date_from = forms.DateTimeField(
        required=False, label=_("Date from"), widget=DateTimePickerInput
    )
    date_to = forms.DateTimeField(
        required=False,
        label=_("Date to"),
        widget=DateTimePickerInput,
        initial=timezone.now(),
    )
    format_choices = (
        ("csv", _("CSV")),
        ("json", _("JSON")),
    )
    file_format = forms.ChoiceField(
        widget=forms.RadioSelect,
        required=True,
        choices=format_choices,
        initial="csv",
        label=_("Get results as"),
    )

server/src/oscarbluelight/templates/oscar/dashboard/vouchers/voucher_add_children.html
{% extends 'oscar/dashboard/layout.html' %}
{% load currency_filters %}
{% load i18n %}

{% block body_class %}{{ block.super }} create-page{% endblock %}

{% block title %}
    {% trans "Add children" %} | {% trans "Vouchers" %} | {{ block.super }}
{% endblock %}

{% block breadcrumbs %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item">
                <a href="{% url 'dashboard:index' %}">{% trans "Dashboard" %}</a>
            </li>
            <li class="breadcrumb-item">
                <a href="{% url 'dashboard:voucher-list' %}">{% trans "Vouchers" %}</a>
            </li>
            <li class="breadcrumb-item">
                <a href="{% url 'dashboard:voucher-stats' pk=voucher.id %}">{{ voucher }}</a>
            </li>
            <li class="breadcrumb-item active" aria-current="page">
                {% trans "Add children" %}
            </li>
        </ol>
    </nav>
{% endblock %}

{% block headertext %}{% trans "Add children" %}{% endblock %}

{% block dashboard_content %}
    <div class="table-header">
        <h2><i class="fas fa-user"></i>{% trans "Add children" %}</h2>
    </div>
    <form action="." method="post" class="card card-body form-stacked">
        {% csrf_token %}
        {% include "oscar/dashboard/partials/form_fields.html" with form=form %}
        {% block form_actions %}
            <div class="form-actions">
                <button class="btn btn-primary" type="submit" data-loading-text="{% trans 'Saving...' %}">{% trans "Save" %}</button> {% trans "or" %}
                <a href="{% url 'dashboard:voucher-list' %}">{% trans "cancel" %}</a>
            </div>
        {% endblock form_actions %}
    </form>

    <script type="text/javascript">
    (function() {
        var typeAuto = document.querySelector('input[name=creation_type][value=auto]');
        var typeManual = document.querySelector('input[name=creation_type][value=manual]');
        var autoGenerateCount = document.querySelector('input[name="auto_generate_count"]');
        var customCodes = document.querySelector('textarea[name="custom_child_codes"]');

        typeAuto.addEventListener('change', function(e) {
            if (!e.currentTarget.checked) {
                return;
            }
            autoGenerateCount.disabled = false;
            customCodes.value = '';
            customCodes.disabled = true;
        });

        typeManual.addEventListener('change', function(e) {
            if (!e.currentTarget.checked) {
                return;
            }
            customCodes.disabled = false;
            autoGenerateCount.value = 0;
            autoGenerateCount.disabled = true;
        });

        typeAuto.click();
    })();
    </script>
{% endblock dashboard_content %}

server/src/oscarbluelight/templates/oscar/dashboard/vouchers/voucher_detail.html
{% extends 'oscar/dashboard/vouchers/voucher_detail.html' %}
{% load currency_filters %}
{% load sorting_tags %}
{% load i18n %}

{% block header %}
    <div class="page-header">
        <div class="float-right">
            <a
                class="btn btn-primary"
                href="{% url 'dashboard:voucher-update' pk=voucher.id %}"
            >
                {% trans "Edit" %}
            </a>
            <a
                class="btn btn-danger"
                href="{% url 'dashboard:voucher-delete' pk=voucher.id %}"
            >
                {% trans "Delete" %}
            </a>
            <form id="status_voucher_form" class="float-right" method="post" action="{% url 'dashboard:voucher-update-suspension-status' pk=object.pk %}">
                {% csrf_token %}
                {% if voucher.is_suspended %}
                    <input type="hidden" name="action" value="unsuspend" />
                    <button type="submit" class="btn btn-success" data-loading-text="{% trans 'Reinstating...' %}">{% trans "Reinstate voucher" %}</button>
                {% else %}
                    <input type="hidden" name="action" value="suspend" />
                    <button type="submit" class="btn btn-secondary" data-loading-text="{% trans 'Suspending...' %}">{% trans "Suspend voucher" %}</button>
                {% endif %}
            </form>
        </div>
        <h1>
            {{ voucher }}
        </h1>
        {% if voucher.is_active %}
            <span class="badge badge-success">{% trans "Active" %}</span>
        {% else %}
            <span class="badge badge-danger">{% trans "Inactive" %}</span>
        {% endif %}
    </div>
{% endblock header %}

{% block dashboard_content %}
    <div class="table-header">
        <h2>{% trans "Voucher details" %}</h2>
    </div>
    {% include "oscar/dashboard/vouchers/partials/voucher_details_table.html" %}

    <div class="table-header">
        <h2>{% trans "Attached offers" %}</h2>
    </div>
    <table class="table table-striped table-bordered table-hover">
        {% if voucher.offers.exists %}
        <thead>
            <tr>
                <th>{% trans "Offer name" %}</th>
                <th>{% trans "Start date" %}</th>
                <th>{% trans "End date" %}</th>
                <th>{% trans "Is available?" %}</th>
                <th>{% trans "Priority" %}</th>
                <th>{% trans "Incentive" %}</th>
                <th>{% trans "Condition" %}</th>
                <th>{% trans "Restrictions" %}</th>
            </tr>
        </thead>
        <tbody>
            {% for offer in voucher.offers.all %}
            <tr>
                <td>
                    <a href="{% url 'dashboard:offer-detail' pk=offer.pk %}">{{ offer.name }}</a>
                </td>
                <td>{{ offer.start_datetime|default:"-" }}</td>
                <td>{{ offer.end_datetime|default:"-" }}</td>
                <td>{% if offer.is_available %}
                    <span class="badge badge-success">{% trans "Yes" %}</span>
                    {% else %}
                    <span class="badge badge-danger">{% trans "No" %}</span>
                    {% endif %}
                </td>
                <td>{{ offer.priority }}</td>
                <td>{{ offer.benefit.description|safe }}</td>
                <td>{{ offer.condition.description|safe }}</td>
                <td>
                    {% for restriction in offer.availability_restrictions %}
                    {% if not restriction.is_satisfied %}
                    <label class="badge badge-danger">
                        {{ restriction.description }}
                    </label>
                    {% else %}
                    {{ restriction.description }}<br/>
                    {% endif %}
                    {% endfor %}
                </td>
            </tr>
            {% endfor %}
        </tbody>
        {% else %}
        <tr>
            <td>{% trans "No offers are attached to this voucher." %}</td>
        </tr>
        {% endif %}
    </table>

    <div class="table-header">
        <h2>{% trans "Voucher performance" %}</h2>
    </div>
    <table class="table table-striped table-bordered table-hover">
        <tbody>
            <tr><th>{% trans "Number of basket additions" %}</th><td>{{ voucher.num_basket_additions }}</td></tr>
            <tr><th>{% trans "Number of orders" %}</th><td>{{ voucher.num_orders }}</td></tr>
            <tr><th>{% trans "Total discount" %}</th><td>{{ voucher.total_discount|currency }}</td></tr>
        </tbody>
    </table>

    <h2>{% trans "Orders that used this voucher" %}</h2>
    <div class="card card-body">
        <form method="get" class="form">
            {% include 'oscar/dashboard/partials/form_fields.html' with form=form %}
            <button type="submit" class="btn btn-primary" data-loading-text="{% trans 'Searching...' %}">
                {% trans "Search" %}
            </button>
            <button
                type="submit"
                class="btn btn-secondary"
                name="format"
                value="csv"
            >
                {% trans "Export to CSV" %}
            </button>
            {% if is_filtered %}
                <a class="btn btn-secondary" href="{% url 'dashboard:voucher-stats' pk=voucher.id %}">
                    {% trans "Reset" %}
                </a>
            {% endif %}
        </form>
    </div>
    <div class="table-header">
        {% if is_filtered %}
            <h2>{% trans "Orders matching search" %}</h2>
        {% else %}
            <h2>{% trans "All orders" %}</h2>
        {% endif %}
    </div>
    <table class="table table-striped table-bordered table-hover">
        {% if not discounts %}
            <tr>
                <td><em>{% trans "No orders have been placed that use this voucher." %}</em></td>
            </tr>
        {% else %}
            <thead>
                <tr>
                    <th>{% trans "Order number" %}</th>
                    <th>{% trans "Order status" %}</th>
                    <th>{% trans "Voucher code" %}</th>
                    <th>{% trans "Order total" %}</th>
                    <th>{% trans "Discount" %}</th>
                    <th>{% trans "Date placed" %}</th>
                </tr>
            </thead>
            <tbody>
                {% for discount in discounts %}
                    {% with order=discount.order %}
                        <tr>
                            <td><a href="{% url 'dashboard:order-detail' number=order.number %}">{{ order.number }}</a></td>
                            <td>{{ order.status }}</td>
                            <td>{{ discount.voucher_code }}</td>
                            <td>{{ order.total_incl_tax|currency:order.currency }}</td>
                            <td>{{ discount.amount|currency:order.currency }}</td>
                            <td>{{ order.date_placed }}</td>
                        </tr>
                    {% endwith %}
                {% endfor %}
            </tbody>
        {% endif %}
    </table>
    {% include 'oscar/dashboard/partials/pagination.html' %}
{% endblock %}

{% block extrastyles %}
    {{ block.super }}
    <style>
        .page-header h1 {
            display: inline;
        }
        #status_voucher_form {
            margin-left: 0.25rem;
        }
    </style>
{% endblock %}

server/src/oscarbluelight/templates/oscar/dashboard/vouchers/voucher_form.html
{% extends 'oscar/dashboard/vouchers/voucher_form.html' %}
{% load currency_filters %}
{% load i18n %}

{% block onbodyload %}
    {{ block.super }}

    // Retrieve and populate the offers field using pagination along with select2's remote data sets feature.
    $("#id_offers").select2({
        ajax: {
            url: '/store/dashboard/offers/offers/',
            data: (params) => {
                return {
                    q: params.term,
                    page: params.page || 1,
                    offer_type: "Voucher",
                    items_per_page: 10,
                };
            },
            dataType: "json",
            cache: true,
        },
        minimumInputLength: 0,
    });
{% endblock %}

{% block extrascripts %}
    {{ block.super }}
    <script type="text/javascript">
    (function() {
        /**
         * User Group Usage Constraint Functionality
         */
        var groupCheckbox = $('#id_limit_usage_by_group');
        var groupSelect = $('#id_groups');

        if (groupCheckbox.length > 0 && groupSelect.length > 0) {
            groupSelect.prop("disabled", !groupCheckbox.get(0).checked);
            groupCheckbox.on('change', function() {
                groupSelect.prop("disabled", !this.checked);
            });
        }
    })();
    </script>
    <script type="text/javascript">
    (function() {
        /**
         * Child Code Functionality
         */
        var childModeNone = document.querySelector('input[name=child_creation_type][value=none]');
        var childModeAuto = document.querySelector('input[name=child_creation_type][value=auto]');
        var childModeManual = document.querySelector('input[name=child_creation_type][value=manual]');
        var autoGenerateCount = document.querySelector('input[name="auto_generate_child_count"]');
        var customCodes = document.querySelector('textarea[name="custom_child_codes"]');

        childModeNone.addEventListener('change', function(e) {
            if (!e.currentTarget.checked) {
                return;
            }
            autoGenerateCount.value = 0;
            autoGenerateCount.disabled = true;
            customCodes.value = '';
            customCodes.disabled = true;
        });

        childModeAuto.addEventListener('change', function(e) {
            if (!e.currentTarget.checked) {
                return;
            }
            autoGenerateCount.disabled = false;
            customCodes.value = '';
            customCodes.disabled = true;
        });

        childModeManual.addEventListener('change', function(e) {
            if (!e.currentTarget.checked) {
                return;
            }
            customCodes.disabled = false;
            autoGenerateCount.value = 0;
            autoGenerateCount.disabled = true;
        });

        childModeNone.click();
    })();
    </script>
{% endblock %}